<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_InsuranceRelPaxDist ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_InsuranceRelPaxDist extends AbstractStructArrayBase
{
    /**
     * The RelPaxDist
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_InsuranceRelPaxDist[]
     */
    public $RelPaxDist;
    /**
     * Constructor method for ArrayOfJP_InsuranceRelPaxDist
     * @uses ArrayOfJP_InsuranceRelPaxDist::setRelPaxDist()
     * @param \StructType\JP_InsuranceRelPaxDist[] $relPaxDist
     */
    public function __construct(array $relPaxDist = array())
    {
        $this
            ->setRelPaxDist($relPaxDist);
    }
    /**
     * Get RelPaxDist value
     * @return \StructType\JP_InsuranceRelPaxDist[]|null
     */
    public function getRelPaxDist()
    {
        return $this->RelPaxDist;
    }
    /**
     * This method is responsible for validating the values passed to the setRelPaxDist method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRelPaxDist method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRelPaxDistForArrayConstraintsFromSetRelPaxDist(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_InsuranceRelPaxDistRelPaxDistItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_InsuranceRelPaxDistRelPaxDistItem instanceof \StructType\JP_InsuranceRelPaxDist) {
                $invalidValues[] = is_object($arrayOfJP_InsuranceRelPaxDistRelPaxDistItem) ? get_class($arrayOfJP_InsuranceRelPaxDistRelPaxDistItem) : sprintf('%s(%s)', gettype($arrayOfJP_InsuranceRelPaxDistRelPaxDistItem), var_export($arrayOfJP_InsuranceRelPaxDistRelPaxDistItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RelPaxDist property can only contain items of type \StructType\JP_InsuranceRelPaxDist, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RelPaxDist value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InsuranceRelPaxDist[] $relPaxDist
     * @return \ArrayType\ArrayOfJP_InsuranceRelPaxDist
     */
    public function setRelPaxDist(array $relPaxDist = array())
    {
        // validation for constraint: array
        if ('' !== ($relPaxDistArrayErrorMessage = self::validateRelPaxDistForArrayConstraintsFromSetRelPaxDist($relPaxDist))) {
            throw new \InvalidArgumentException($relPaxDistArrayErrorMessage, __LINE__);
        }
        $this->RelPaxDist = $relPaxDist;
        return $this;
    }
    /**
     * Add item to RelPaxDist value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InsuranceRelPaxDist $item
     * @return \ArrayType\ArrayOfJP_InsuranceRelPaxDist
     */
    public function addToRelPaxDist(\StructType\JP_InsuranceRelPaxDist $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_InsuranceRelPaxDist) {
            throw new \InvalidArgumentException(sprintf('The RelPaxDist property can only contain items of type \StructType\JP_InsuranceRelPaxDist, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RelPaxDist[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_InsuranceRelPaxDist|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_InsuranceRelPaxDist|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_InsuranceRelPaxDist|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_InsuranceRelPaxDist|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_InsuranceRelPaxDist|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RelPaxDist
     */
    public function getAttributeName()
    {
        return 'RelPaxDist';
    }
}
